# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['AccountArgs', 'Account']

@pulumi.input_type
class AccountArgs:
    def __init__(__self__, *,
                 handle: pulumi.Input[str],
                 allow_public_workspaces: Optional[pulumi.Input[bool]] = None,
                 billing_email: Optional[pulumi.Input[str]] = None,
                 link: Optional[pulumi.Input[str]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a Account resource.
        :param pulumi.Input[str] handle: Unique handle of the account
        :param pulumi.Input[bool] allow_public_workspaces: Whether or not this account allows public workspaces
        :param pulumi.Input[str] billing_email: Billing email to apply to the account's Stripe customer
        :param pulumi.Input[str] link: An optional for an external url associated with the account, e.g. https://prefect.io/
        :param pulumi.Input[str] location: An optional physical location for the account, e.g. Washington, D.C.
        :param pulumi.Input[str] name: Name of the account
        """
        pulumi.set(__self__, "handle", handle)
        if allow_public_workspaces is not None:
            pulumi.set(__self__, "allow_public_workspaces", allow_public_workspaces)
        if billing_email is not None:
            pulumi.set(__self__, "billing_email", billing_email)
        if link is not None:
            pulumi.set(__self__, "link", link)
        if location is not None:
            pulumi.set(__self__, "location", location)
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def handle(self) -> pulumi.Input[str]:
        """
        Unique handle of the account
        """
        return pulumi.get(self, "handle")

    @handle.setter
    def handle(self, value: pulumi.Input[str]):
        pulumi.set(self, "handle", value)

    @property
    @pulumi.getter(name="allowPublicWorkspaces")
    def allow_public_workspaces(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether or not this account allows public workspaces
        """
        return pulumi.get(self, "allow_public_workspaces")

    @allow_public_workspaces.setter
    def allow_public_workspaces(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "allow_public_workspaces", value)

    @property
    @pulumi.getter(name="billingEmail")
    def billing_email(self) -> Optional[pulumi.Input[str]]:
        """
        Billing email to apply to the account's Stripe customer
        """
        return pulumi.get(self, "billing_email")

    @billing_email.setter
    def billing_email(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "billing_email", value)

    @property
    @pulumi.getter
    def link(self) -> Optional[pulumi.Input[str]]:
        """
        An optional for an external url associated with the account, e.g. https://prefect.io/
        """
        return pulumi.get(self, "link")

    @link.setter
    def link(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "link", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[str]]:
        """
        An optional physical location for the account, e.g. Washington, D.C.
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the account
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)


@pulumi.input_type
class _AccountState:
    def __init__(__self__, *,
                 allow_public_workspaces: Optional[pulumi.Input[bool]] = None,
                 billing_email: Optional[pulumi.Input[str]] = None,
                 created: Optional[pulumi.Input[str]] = None,
                 handle: Optional[pulumi.Input[str]] = None,
                 link: Optional[pulumi.Input[str]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 updated: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering Account resources.
        :param pulumi.Input[bool] allow_public_workspaces: Whether or not this account allows public workspaces
        :param pulumi.Input[str] billing_email: Billing email to apply to the account's Stripe customer
        :param pulumi.Input[str] created: Timestamp of when the resource was created (RFC3339)
        :param pulumi.Input[str] handle: Unique handle of the account
        :param pulumi.Input[str] link: An optional for an external url associated with the account, e.g. https://prefect.io/
        :param pulumi.Input[str] location: An optional physical location for the account, e.g. Washington, D.C.
        :param pulumi.Input[str] name: Name of the account
        :param pulumi.Input[str] updated: Timestamp of when the resource was updated (RFC3339)
        """
        if allow_public_workspaces is not None:
            pulumi.set(__self__, "allow_public_workspaces", allow_public_workspaces)
        if billing_email is not None:
            pulumi.set(__self__, "billing_email", billing_email)
        if created is not None:
            pulumi.set(__self__, "created", created)
        if handle is not None:
            pulumi.set(__self__, "handle", handle)
        if link is not None:
            pulumi.set(__self__, "link", link)
        if location is not None:
            pulumi.set(__self__, "location", location)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if updated is not None:
            pulumi.set(__self__, "updated", updated)

    @property
    @pulumi.getter(name="allowPublicWorkspaces")
    def allow_public_workspaces(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether or not this account allows public workspaces
        """
        return pulumi.get(self, "allow_public_workspaces")

    @allow_public_workspaces.setter
    def allow_public_workspaces(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "allow_public_workspaces", value)

    @property
    @pulumi.getter(name="billingEmail")
    def billing_email(self) -> Optional[pulumi.Input[str]]:
        """
        Billing email to apply to the account's Stripe customer
        """
        return pulumi.get(self, "billing_email")

    @billing_email.setter
    def billing_email(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "billing_email", value)

    @property
    @pulumi.getter
    def created(self) -> Optional[pulumi.Input[str]]:
        """
        Timestamp of when the resource was created (RFC3339)
        """
        return pulumi.get(self, "created")

    @created.setter
    def created(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "created", value)

    @property
    @pulumi.getter
    def handle(self) -> Optional[pulumi.Input[str]]:
        """
        Unique handle of the account
        """
        return pulumi.get(self, "handle")

    @handle.setter
    def handle(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "handle", value)

    @property
    @pulumi.getter
    def link(self) -> Optional[pulumi.Input[str]]:
        """
        An optional for an external url associated with the account, e.g. https://prefect.io/
        """
        return pulumi.get(self, "link")

    @link.setter
    def link(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "link", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[str]]:
        """
        An optional physical location for the account, e.g. Washington, D.C.
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the account
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def updated(self) -> Optional[pulumi.Input[str]]:
        """
        Timestamp of when the resource was updated (RFC3339)
        """
        return pulumi.get(self, "updated")

    @updated.setter
    def updated(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "updated", value)


class Account(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 allow_public_workspaces: Optional[pulumi.Input[bool]] = None,
                 billing_email: Optional[pulumi.Input[str]] = None,
                 handle: Optional[pulumi.Input[str]] = None,
                 link: Optional[pulumi.Input[str]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        ## Example Usage

        ## Import

        Prefect Accounts can be imported using the account's UUID

        ```sh
        $ pulumi import prefect:index/account:Account example 00000000-0000-0000-0000-000000000000
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] allow_public_workspaces: Whether or not this account allows public workspaces
        :param pulumi.Input[str] billing_email: Billing email to apply to the account's Stripe customer
        :param pulumi.Input[str] handle: Unique handle of the account
        :param pulumi.Input[str] link: An optional for an external url associated with the account, e.g. https://prefect.io/
        :param pulumi.Input[str] location: An optional physical location for the account, e.g. Washington, D.C.
        :param pulumi.Input[str] name: Name of the account
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: AccountArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        ## Example Usage

        ## Import

        Prefect Accounts can be imported using the account's UUID

        ```sh
        $ pulumi import prefect:index/account:Account example 00000000-0000-0000-0000-000000000000
        ```

        :param str resource_name: The name of the resource.
        :param AccountArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(AccountArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 allow_public_workspaces: Optional[pulumi.Input[bool]] = None,
                 billing_email: Optional[pulumi.Input[str]] = None,
                 handle: Optional[pulumi.Input[str]] = None,
                 link: Optional[pulumi.Input[str]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = AccountArgs.__new__(AccountArgs)

            __props__.__dict__["allow_public_workspaces"] = allow_public_workspaces
            __props__.__dict__["billing_email"] = billing_email
            if handle is None and not opts.urn:
                raise TypeError("Missing required property 'handle'")
            __props__.__dict__["handle"] = handle
            __props__.__dict__["link"] = link
            __props__.__dict__["location"] = location
            __props__.__dict__["name"] = name
            __props__.__dict__["created"] = None
            __props__.__dict__["updated"] = None
        super(Account, __self__).__init__(
            'prefect:index/account:Account',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            allow_public_workspaces: Optional[pulumi.Input[bool]] = None,
            billing_email: Optional[pulumi.Input[str]] = None,
            created: Optional[pulumi.Input[str]] = None,
            handle: Optional[pulumi.Input[str]] = None,
            link: Optional[pulumi.Input[str]] = None,
            location: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None,
            updated: Optional[pulumi.Input[str]] = None) -> 'Account':
        """
        Get an existing Account resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] allow_public_workspaces: Whether or not this account allows public workspaces
        :param pulumi.Input[str] billing_email: Billing email to apply to the account's Stripe customer
        :param pulumi.Input[str] created: Timestamp of when the resource was created (RFC3339)
        :param pulumi.Input[str] handle: Unique handle of the account
        :param pulumi.Input[str] link: An optional for an external url associated with the account, e.g. https://prefect.io/
        :param pulumi.Input[str] location: An optional physical location for the account, e.g. Washington, D.C.
        :param pulumi.Input[str] name: Name of the account
        :param pulumi.Input[str] updated: Timestamp of when the resource was updated (RFC3339)
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _AccountState.__new__(_AccountState)

        __props__.__dict__["allow_public_workspaces"] = allow_public_workspaces
        __props__.__dict__["billing_email"] = billing_email
        __props__.__dict__["created"] = created
        __props__.__dict__["handle"] = handle
        __props__.__dict__["link"] = link
        __props__.__dict__["location"] = location
        __props__.__dict__["name"] = name
        __props__.__dict__["updated"] = updated
        return Account(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="allowPublicWorkspaces")
    def allow_public_workspaces(self) -> pulumi.Output[Optional[bool]]:
        """
        Whether or not this account allows public workspaces
        """
        return pulumi.get(self, "allow_public_workspaces")

    @property
    @pulumi.getter(name="billingEmail")
    def billing_email(self) -> pulumi.Output[Optional[str]]:
        """
        Billing email to apply to the account's Stripe customer
        """
        return pulumi.get(self, "billing_email")

    @property
    @pulumi.getter
    def created(self) -> pulumi.Output[str]:
        """
        Timestamp of when the resource was created (RFC3339)
        """
        return pulumi.get(self, "created")

    @property
    @pulumi.getter
    def handle(self) -> pulumi.Output[str]:
        """
        Unique handle of the account
        """
        return pulumi.get(self, "handle")

    @property
    @pulumi.getter
    def link(self) -> pulumi.Output[Optional[str]]:
        """
        An optional for an external url associated with the account, e.g. https://prefect.io/
        """
        return pulumi.get(self, "link")

    @property
    @pulumi.getter
    def location(self) -> pulumi.Output[Optional[str]]:
        """
        An optional physical location for the account, e.g. Washington, D.C.
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Name of the account
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def updated(self) -> pulumi.Output[str]:
        """
        Timestamp of when the resource was updated (RFC3339)
        """
        return pulumi.get(self, "updated")

